CREATE OR REPLACE TRIGGER STATUS_LOTECTB_MOVBANCARIO BEFORE DELETE ON MOVBANCARIO
FOR EACH ROW
DECLARE
  V_CDLOTE VARCHAR2(20);
  V_NRLANCLOTE VARCHAR2(06);
  V_DTINICCTBL DATE;
  V_DTFINACCTBL DATE;
  V_CDEMPRESA VARCHAR(2);
  V_IDTPGERACAOCONT VARCHAR2(2);
BEGIN
   BEGIN
      SELECT IDTPGERACAOCONT
        INTO V_IDTPGERACAOCONT
        FROM PARAMCTBL;
   EXCEPTION
    WHEN NO_DATA_FOUND THEN
      V_IDTPGERACAOCONT := NULL;
   END;

   IF V_IDTPGERACAOCONT <> 'O' THEN

      IF :OLD.IDMOVBANC = 'C' THEN
         BEGIN
           SELECT MAX(CDEMPRESA)
             INTO V_CDEMPRESA
             FROM MOVCREDBANC
            WHERE CDREDUCONT = :OLD.CDREDUCONT
              AND NRMOVBANC = :OLD.NRMOVBANC;
         EXCEPTION
           WHEN NO_DATA_FOUND THEN
             V_CDEMPRESA := NULL;
         END;
      ELSE
         BEGIN
           SELECT MAX(CDEMPRESA)
             INTO V_CDEMPRESA
             FROM MOVDEBBANC
            WHERE CDREDUCONT = :OLD.CDREDUCONT
              AND NRMOVBANC = :OLD.NRMOVBANC;
         EXCEPTION
           WHEN NO_DATA_FOUND THEN
             V_CDEMPRESA := NULL;
         END;
      END IF;

      BEGIN
         SELECT DTINICCTBL, DTFINACCTBL
           INTO V_DTINICCTBL, V_DTFINACCTBL
           FROM CONTOPECTBL
          WHERE CDEMPRESA = V_CDEMPRESA;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
         V_DTINICCTBL := NULL;
         V_DTFINACCTBL := NULL;
      END;

      IF DELETING THEN
         IF ((:OLD.DTMOVBANC >= V_DTINICCTBL AND :OLD.DTMOVBANC <= V_DTFINACCTBL) OR (V_CDEMPRESA IS NULL)) THEN
            BEGIN
               SELECT MAX(CDLOTE) AS CDLOTE, MAX(NRLANCLOTE) AS NRLANCLOTE
                 INTO V_CDLOTE, V_NRLANCLOTE
                 FROM RELAMBANCLANLOT
                WHERE  CDREDUCONT = :OLD.CDREDUCONT
                  AND  NRMOVBANC = :OLD.NRMOVBANC;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                 V_CDLOTE := NULL;
                 V_NRLANCLOTE := NULL;
            END;

            REVERTE_LOTE(V_CDEMPRESA,V_CDLOTE);

            DELETE FROM RELAMBANCLANLOT
             WHERE CDEMPRESA = V_CDEMPRESA
               AND NRLANCLOTE = V_NRLANCLOTE
               AND CDREDUCONT = :OLD.CDREDUCONT
               AND NRMOVBANC = :OLD.NRMOVBANC;

            DELETE FROM LANCLOTE
             WHERE CDEMPRESA = V_CDEMPRESA
               AND CDLOTE = V_CDLOTE
               AND NRLANCLOTE = V_NRLANCLOTE;

        ELSE
            RAISE_APPLICATION_ERROR(-20501,'Excluso no permitida, data da movimentao fora do perodo de integrao financeiro.',True);
         END IF;
      END IF;
   END IF;
END;
/


